//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "ieopensavedlg"
#pragma link "ieview"
#pragma link "imageenview"
#pragma link "imageenproc"
#pragma link "cspin"
#pragma link "cxContainer"
#pragma link "cxControls"
#pragma link "cxEdit"
#pragma link "cxGraphics"
#pragma link "cxLookAndFeelPainters"
#pragma link "cxLookAndFeels"
#pragma link "cxMaskEdit"
#pragma link "cxSpinEdit"
#pragma link "cxTextEdit"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
grayScale = 0;
Label1->Caption = "";
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton1Click(TObject *Sender)
{
if (openDialog->Execute())
   {
   PaintView->IO->LoadFromFile(openDialog->FileName);
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton2Click(TObject *Sender)
{
// pointer to original image
origImage = PaintView->IEBitmap;
// copy of original image
editImage = new TIEBitmap(origImage);
// original image converted to grayscale
grayScale = new TIEBitmap(origImage);
ienProc->AttachedIEBitmap = grayScale;
ienProc->ConvertToGray();
//
Label1->Caption = "Convolving";
this->Refresh();
//
PaintView->Proc->SaveUndo();
int i, j, k, m, shiftKer = 1, nW, nH;
float mult = editMult->Value;
float bias = editBias->Value;
// filters
TGraphFilter filter;
switch (comboFilter->ItemIndex)
   {
   case 0:
		ienProc->EdgeDetect_Sobel();
		break;
   case 1:
		{
		int fHighPass[3][3] = { {-1, -1, -1}, {-1, 8, -1}, {-1, -1, -1} };
		for (i = 0; i < 3; i++)
			{
			for (j = 0; j < 3; j++)
			filter.Values[i][j] =  fHighPass[i][j];
			}
		filter.Divisor = 1;
		ienProc->ApplyFilter(filter);
		}
		break;
   case 2:
		{
		int fTopHat[3][3] = {{-1, -2, -1},{-2, 12, -2},{-1, -2, -1}};
		for (i = 0; i < 3; i++)
			{
			for (j = 0; j < 3; j++)
			filter.Values[i][j] =  fTopHat[i][j];
			}
		filter.Divisor = 1;
		ienProc->ApplyFilter(filter);
		}
		break;
   default:
		break;
}
ienProc->AttachedIEBitmap = 0;
// test filter
//grayScale->DrawToTIEBitmap(origImage, 0, 0);
//PaintView->Update();
//return;
grayScale->PixelFormat = ie8g;
//
if (mult == 0)
   mult = 1.0;
// laod pixels into array
BYTE *gray_line, *edit_line, *orig_line;
// create arrays
// convolution kernel -> bigger images to avoid ifs in loops
nH = grayScale->Height + shiftKer * 2;
nW = grayScale->Width  + shiftKer * 2;
// convolution data
gS = new float *[nH];
// channels
rC = new BYTE *[nH];
bC = new BYTE *[nH];
gC = new BYTE *[nH];
//
// kerenel without border wrapping => 0x00
//
//TODO: wrap edges if checked
for (i = 0; i < nH; i++)
	{
	gS[i] = new float[nW];
	rC[i] = new BYTE[nW];
	gC[i] = new BYTE[nW];
	bC[i] = new BYTE[nW];
	for (j = 0; j < nW; j++)
		{
		gS[i][j] = 0;
		rC[i][j] = 0x00;
		gC[i][j] = 0x00;
		bC[i][j] = 0x00;
		}
	}
// load data
for (i = 0; i < grayScale->Height; i++)
	{
	gray_line =  (BYTE*)grayScale->ScanLine[i];
	orig_line =  (BYTE*)origImage->ScanLine[i];
	for (j = 0; j < grayScale->Width; j++)
		{
		gS[i+shiftKer][j+shiftKer] = (float)(*gray_line) / 255.0; gray_line++;
		bC[i+shiftKer][j+shiftKer] = *orig_line; orig_line++;
		gC[i+shiftKer][j+shiftKer] = *orig_line; orig_line++;
		rC[i+shiftKer][j+shiftKer] = *orig_line; orig_line++;
		}
	}
// perform convolution - todo
for (i = 0; i < grayScale->Height; i++)
	{
	edit_line =  (BYTE*)editImage->ScanLine[i];
	for (j = 0; j < grayScale->Width; j++)
		{
		_ii = i + shiftKer;
		_jj = j + shiftKer;
		doConvolve();
		for (k = 0; k < 3; k++)
			{
			//if (totConv > 0)
			//   convChans[k] = convChans[k] / totConv;
			if (chkTotConv->Checked)
			   convChans[k] = convChans[k] * totConv;
			convChans[k] = bias + convChans[k] * mult;
			*edit_line  = normColor((int)convChans[k]); edit_line++;
			}
		}
	}
editImage->DrawToTIEBitmap(origImage, 0, 0);
for (i = 0; i < nH; i++)
	{
	delete []gS[i];
	delete []rC[i];
	delete []gC[i];
	delete []bC[i];
	}
delete gS;
delete rC;
delete gC;
delete bC;
PaintView->Update();
delete grayScale;
delete editImage;
Label1->Caption = "Done";
this->Refresh();
}
//---------------------------------------------------------------------------
BYTE __fastcall TForm1::normColor(int pixel)
{
if (pixel > 255)
   return 0xff;
else if (pixel < 0)
   return 0x00;
return (BYTE)pixel;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::doConvolve(void)
{
convChans[0] = convChans[1] = convChans[2] = totConv = 0.0;
int k, m;
for (k = -1 ; k < 2; k++)
	{
	for (m = -1; m < 2; m++)
		{
		convChans[0] += gS[_ii+k][_jj+m] * (float)bC[_ii+k][_jj+m];
		convChans[1] +=	gS[_ii+k][_jj+m] * (float)gC[_ii+k][_jj+m];
		convChans[2] +=	gS[_ii+k][_jj+m] * (float)rC[_ii+k][_jj+m];
		totConv += (float)gS[_ii+k][_jj+m];
		}
	}
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SpeedButton3Click(TObject *Sender)
{
PaintView->Proc->Undo(true);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton4Click(TObject *Sender)
{
if (saveDialog->Execute())
   {
   PaintView->IO->SaveToFile(saveDialog->FileName);
   }
}
//---------------------------------------------------------------------------

